(***************************************************************)
(*                                                             *)
(*                 camlgrenouille for Linux                    *)
(*                                                             *)
(*             Copyright 2001-2003 Alan Schmitt                *)
(*              alan.schmitt@polytechnique.org                 *)
(*                                                             *)
(* This file is distributed under the terms of the GNU General *)
(* Public License.                                             *)
(*                                                             *)
(***************************************************************)

open Char

let clef = "pasfaciledetrouverlaclefpourouvrirlaporte"

let a = code 'a'

let z = code 'z'

let zero = code '0'

let nine = code '9'

let crypt_one_letter pass key =
  let p = code (lowercase pass) in
  let k = code key in
  if p >= a && p <= z then
    String.make 1 (chr (((p + k) mod 26) + a))
  else if p >= zero && p <= nine then
    String.make 1 (chr (((p + k) mod 10) + zero))
  else
    "_"

let crypt password = 
  let rec crypt_rec i =
    if i = String.length password then ""
    else crypt_rec (i + 1) ^
      (crypt_one_letter (String.get password i) (String.get clef i))
  in
  crypt_rec 0
