(***************************************************************)
(*                                                             *)
(*                 camlgrenouille for Linux                    *)
(*                                                             *)
(*             Copyright 2001-2003 Alan Schmitt                *)
(*              alan.schmitt@polytechnique.org                 *)
(*                                                             *)
(* This file is distributed under the terms of the GNU General *)
(* Public License.                                             *)
(*                                                             *)
(***************************************************************)

type debug = Debug | Normal | Quiet

let debug_val = ref Normal

let debug_prefix = ref (fun () -> "")

let set_debug_level l =
  debug_val := l

let set_debug_prefix f =
  debug_prefix := f

let dprint level s =
  match !debug_val with
  | Quiet -> ()
  | Debug ->
      print_string (!debug_prefix ());
      print_string s;
      print_newline ()
  | Normal ->
      match level with
      |	Normal -> 
	  print_string (!debug_prefix ());
	  print_string s;
	  print_newline ()
      |	_ -> ()
