(************************************************************************)
(*                                                                      *)
(*                        Caml Development Kit                          *)
(*                                                                      *)
(*                 Projet Moscova, INRIA Rocquencourt                   *)
(*                                                                      *)
(************************************************************************)

(* the debugging levels, from highest to lowest
   Quiet does not print anything
*)
type debug = Debug | Normal | Quiet

(* to set the current debugging level *)
val set_debug_level : debug -> unit

(* set debug prefix: this unit -> string function will always be called
   when debug printing occurs, and the result will prefix the message *)
val set_debug_prefix : (unit -> string) -> unit

(* to print on stdout according to the current level and the
   given level.
   A newline is always added
*)
val dprint : debug -> string -> unit
