(***************************************************************)
(*                                                             *)
(*                 camlgrenouille for Linux                    *)
(*                                                             *)
(*             Copyright 2001-2003 Alan Schmitt                *)
(*              alan.schmitt@polytechnique.org                 *)
(*                                                             *)
(* This file is distributed under the terms of the GNU General *)
(* Public License.                                             *)
(*                                                             *)
(***************************************************************)

(* functions to deal with timouts *)
exception Timeout

let notimer ={ Unix.it_interval=0.0 ; Unix.it_value = 0.0 }

let handler = Sys.Signal_handle 
    (fun _ -> 
      Sys.set_signal Sys.sigalrm Sys.Signal_default ;
      ignore (Unix.setitimer Unix.ITIMER_REAL notimer);
      raise Timeout)
    
let timeout time f x =
  Sys.set_signal Sys.sigalrm handler;
  let timer = { Unix.it_interval= 0. ; Unix.it_value = time } in
  ignore (Unix.setitimer Unix.ITIMER_REAL timer);
  let res = 
    try
      (f x) 
    with
    | e -> 
	ignore (Unix.setitimer Unix.ITIMER_REAL notimer);
	raise e
  in
  ignore (Unix.setitimer Unix.ITIMER_REAL notimer);
  res
